.global _main, _nmi_vector, _irq_timer_vector, _irq_dma_vector;

        .export         _exit
        .import         initlib, donelib
        .import         push0, zerobss

	.include "zeropage.inc"
	.include "supervision.inc"

.data
_irq_dma_vector: .word 0
_irq_timer_vector: .word 0
_nmi_vector: .word 0
	
.code

reset:
	jsr	zerobss
	lda	#>$2000
	stz	sp
	sta	sp+1
	jsr	initlib
.if 0
	; doesn't make much sense in the cartridge of a console
	jsr	push0
	jsr	push0
	ldy	#4
	jsr	_main
_exit:
	jsr	donelib
.else
	jsr	_main
_exit:
.endif
forever:jmp	forever

.proc irq
	pha
	phx
	phy
	lda	sv_irq_source
	and	#SV_IRQ_REQUEST_TIMER
	beq	not_timer
	lda	sv_timer_quit
	ldy	#0
	jsr	jmpindt
not_timer:
	lda	sv_irq_source
	and	#SV_IRQ_REQUEST_DMA
	beq	not_dma
	lda	sv_dma_quit
	ldy	#0
	jsr	jmpindd
not_dma:
	ply
	plx
	pla
	rti
jmpindt:jmp	(_irq_timer_vector)
jmpindd:jmp	(_irq_dma_vector)
.endproc

.proc nmi
	pha
	phx
	phy
	ldy	#0
	jsr	jmpind
	ply
	plx
	pla
	rti
jmpind: jmp	(_nmi_vector)	
.endproc


.if 0
        .segment "FFF0"
.proc reset32kcode
        lda     #(6<<5)
        sta     sv_bank
; now the 32kbyte image can reside in the top of 64kbyte, 128kbyte roms
        jmp     reset
.endproc
        .segment "VECTOR"
.word nmi,reset32kcode,irq
.else
        .segment "VECTOR"
.word nmi,reset,irq
.endif
