	;; ca65 --cpu 65C02 -o test.o test.s
	;; ld65 -t none -o test.bin test.o

	;;  supervision probably 65c02s

	.include "supervision.inc"		
	.include "common.inc"

	.zeropage
nmic:	.byte 0
timerc:	.byte 0
dmac:	.byte 0
	
	.data

	.rodata
;	.segment "BANK1"
;	.segment "BANK2"
;	.segment "BANK3"
;	.segment "BANK4"
;	.segment "BANK5"
;	.segment "BANK6"
;	.segment "BANK7"

	.code

.proc reset
	sei
	cld	
	ldx	#$ff
	txs

	lda	#$a0
	sta	lcd_width
	sta	lcd_height
	stz 	lcd_xpos
	stz 	lcd_ypos
	
	lda	#$ff
	sta	sv_timer_count

	lda 	#SV_LCD_ON|SV_NMI_ENABLE_ON|SV_IRQ_ENABLE_TIMER|SV_IRQ_ENABLE_DMA|SV_TIMER_MODE_240Hz|(6<<5)
	sta	sv_bank

	stz	sv_audio_left_control
	stz	sv_audio_right_control
	stz	sv_dma_control
	stz	sv_noise_control

	; most programs do this
	lda	#$f
	sta	$2022

	stz	timerc
	stz	dmac
	stz	nmic
	cli
background:
	ldx	#0
	ldy	#0
	jsr	draw_set_cursor
	lda	nmic
	jsr	draw_hex

	ldx	#3
	ldy	#0
	jsr	draw_set_cursor
	lda	timerc
	jsr	draw_hex

	jmp background
	.endproc
			
	
.proc irq
	pha
;	phx
;	phy
	lda	sv_irq_source
	lsr	a
	bcc	not_timer
	inc	timerc
	lda	#$7f
	sta	sv_timer_count
	lda	sv_timer_quit
	bra irq_end
not_timer:
	lsr	a
	bcc	not_dma
	inc	dmac
	lda	sv_dma_quit
;	bra	irq_end
not_dma:
irq_end:
;	ply
;	plx
	pla
	rti
	.endproc
	
.proc nmi
;	pha
;	phx
;	phy	
	inc nmic
;	ply
;	plx
;	pla
	rti
	.endproc

.if 0
	.segment "FFF0"	
.proc reset32kcode
	lda	#(6<<5)
	sta	sv_bank
; now the 32kbyte image can reside in the top of 64kbyte, 128kbyte roms
	jmp	reset
.endproc
	.segment "VECTOR"
.word nmi,reset32kcode,irq
.else
	.segment "VECTOR"
.word nmi,reset,irq
.endif
